## wabt 1.0.16

=== CMakeLists.txt ===
#
# Copyright 2016 WebAssembly Community Group participants
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

cmake_minimum_required(VERSION 3.0.0)
project(WABT VERSION 1.0.13)

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

# For git users, attempt to generate a more useful version string
if (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/.git)
  find_package(Git QUIET REQUIRED)
  execute_process(COMMAND
          "${GIT_EXECUTABLE}" --git-dir=${CMAKE_CURRENT_SOURCE_DIR}/.git describe --tags
          RESULT_VARIABLE
              GIT_VERSION_RESULT
          OUTPUT_VARIABLE
              GIT_VERSION
          OUTPUT_STRIP_TRAILING_WHITESPACE)
  if (${GIT_VERSION_RESULT})
    message(WARNING "Error running git describe to determine version")
  else ()
    set(CMAKE_PROJECT_VERSION "${CMAKE_PROJECT_VERSION} (${GIT_VERSION})")
  endif ()
endif ()

option(BUILD_TESTS "Build GTest-based tests" ON)
option(USE_SYSTEM_GTEST "Use system GTest, instead of building" OFF)
option(BUILD_TOOLS "Build wabt commandline tools" ON)
option(BUILD_LIBWASM "Build libwasm" ON)
option(USE_ASAN "Use address sanitizer" OFF)
option(USE_MSAN "Use memory sanitizer" OFF)
option(USE_LSAN "Use leak sanitizer" OFF)
option(USE_UBSAN "Use undefined behavior sanitizer" OFF)
option(CODE_COVERAGE "Build with code coverage enabled" OFF)
option(WITH_EXCEPTIONS "Build with exceptions enabled" OFF)
option(WERROR "Build with warnings as errors" OFF)
# WASI support is still a work in progress.
# Only a handful of syscalls are supported at this point.
option(WITH_WASI "Build WASI support via uvwasi" OFF)

if (MSVC)
  set(COMPILER_IS_CLANG 0)
  set(COMPILER_IS_GNU 0)
  set(COMPILER_IS_MSVC 1)
elseif (CMAKE_C_COMPILER_ID MATCHES "Clang")
  set(COMPILER_IS_CLANG 1)
  set(COMPILER_IS_GNU 0)
  set(COMPILER_IS_MSVC 0)
elseif (CMAKE_C_COMPILER_ID STREQUAL "GNU")
  set(COMPILER_IS_CLANG 0)
  set(COMPILER_IS_GNU 1)
  set(COMPILER_IS_MSVC 0)
elseif (CMAKE_SYSTEM_NAME STREQUAL "Emscripten")
  set(COMPILER_IS_CLANG 1)
  set(COMPILER_IS_GNU 0)
  set(COMPILER_IS_MSVC 0)
else ()
  set(COMPILER_IS_CLANG 0)
  set(COMPILER_IS_GNU 0)
  set(COMPILER_IS_MSVC 0)
endif ()

include(CheckIncludeFile)
include(CheckSymbolExists)

check_include_file("alloca.h" HAVE_ALLOCA_H)
check_include_file("unistd.h" HAVE_UNISTD_H)
check_symbol_exists(snprintf "stdio.h" HAVE_SNPRINTF)
check_symbol_exists(strcasecmp "strings.h" HAVE_STRCASECMP)

if (WIN32)
  check_symbol_exists(ENABLE_VIRTUAL_TERMINAL_PROCESSING "windows.h" HAVE_WIN32_VT100)
endif ()

include(CheckTypeSize)
check_type_size(ssize_t SSIZE_T)
check_type_size(size_t SIZEOF_SIZE_T)

configure_file(
  ${WABT_SOURCE_DIR}/src/config.h.in
  ${WABT_BINARY_DIR}/config.h
)

include_directories(${WABT_SOURCE_DIR} ${WABT_BINARY_DIR})

if (COMPILER_IS_MSVC)
  # disable warning C4018: signed/unsigned mismatch
  # disable warning C4056, C4756: overflow in floating-point constant arithmetic
  #   seems to not like float compare w/ HUGE_VALF; bug?
  # disable warnings C4267 and C4244: conversion/truncation from larger to smaller type.
  # disable warning C4800: implicit conversion from larger int to bool
  add_definitions(-W3 -wd4018 -wd4056 -wd4756 -wd4267 -wd4244 -wd4800 -D_CRT_SECURE_NO_WARNINGS -D_SCL_SECURE_NO_WARNINGS)

  if (WERROR)
    add_definitions(-WX)
  endif ()

  if (NOT WITH_EXCEPTIONS)
    # disable exception use in C++ library
    add_definitions(-D_HAS_EXCEPTIONS=0)
  endif ()
else ()
  # disable -Wunused-parameter: this is really common when implementing
  #   interfaces, etc.
  # disable -Wpointer-arith: this is a GCC extension, and doesn't work in MSVC.
  add_definitions(
    -Wall -Wextra -Wno-unused-parameter -Wpointer-arith -g
    -Wuninitialized
  )

  set(CMAKE_CXX_EXTENSIONS OFF)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Wold-style-cast")

  if (WERROR)
    add_definitions(-Werror)
  endif ()

  if (NOT WITH_EXCEPTIONS)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-exceptions")
  endif ()

  # Need to define __STDC_*_MACROS because C99 specifies that C++ shouldn't
  # define format (e.g. PRIu64) or limit (e.g. UINT32_MAX) macros without the
  # definition, and some libcs (e.g. glibc2.17 and earlier) follow that.
  add_definitions(-D__STDC_LIMIT_MACROS=1 -D__STDC_FORMAT_MACROS=1)

  if (MINGW OR CYGWIN)
    # On MINGW, _POSIX_C_SOURCE is needed to ensure we use mingw printf
    # instead of the VC runtime one.
    add_definitions(-D_POSIX_C_SOURCE=200809L)
  endif()

  if (COMPILER_IS_GNU)
    # disable -Wclobbered: it seems to be guessing incorrectly about a local
    # variable being clobbered by longjmp.
    add_definitions(-Wno-clobbered)
  endif ()

  if (NOT EMSCRIPTEN)
    # try to get the target architecture by compiling a dummy.c file and
    # checking the architecture using the file command.
    file(WRITE ${WABT_BINARY_DIR}/dummy.c "main(){}")
    try_compile(
      COMPILE_OK
      ${WABT_BINARY_DIR}
      ${WABT_BINARY_DIR}/dummy.c
      COPY_FILE ${WABT_BINARY_DIR}/dummy
    )
    if (COMPILE_OK)
      execute_process(
        COMMAND file ${WABT_BINARY_DIR}/dummy
        RESULT_VARIABLE FILE_RESULT
        OUTPUT_VARIABLE FILE_OUTPUT
        ERROR_QUIET
      )

      if (FILE_RESULT EQUAL 0)
        if (${FILE_OUTPUT} MATCHES "x86[-_]64")
          set(TARGET_ARCH "x86-64")
        elseif (${FILE_OUTPUT} MATCHES "Intel 80386")
          set(TARGET_ARCH "i386")
        elseif (${FILE_OUTPUT} MATCHES "ARM")
          set(TARGET_ARCH "ARM")
        else ()
          message(WARNING "Unknown target architecture!")
        endif ()
      else ()
        message(WARNING "Error running `file` command on dummy executable")
      endif ()
    else ()
      message(WARNING "Error compiling dummy.c file")
    endif ()

    if (TARGET_ARCH STREQUAL "i386")
      # wasm doesn't allow for x87 floating point math
      add_definitions(-msse2 -mfpmath=sse)
    endif ()
  endif ()
endif ()

set(USE_SANITIZER FALSE)

function(sanitizer NAME FLAGS)
  if (${NAME})
    if (USE_SANITIZER)
      message(FATAL_ERROR "Only one sanitizer allowed")
    endif ()
    set(USE_SANITIZER TRUE PARENT_SCOPE)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${FLAGS}" PARENT_SCOPE)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${FLAGS}" PARENT_SCOPE)
  endif ()
endfunction()
sanitizer(USE_ASAN "-fsanitize=address")
sanitizer(USE_MSAN "-fsanitize=memory")
sanitizer(USE_LSAN "-fsanitize=leak")

if (USE_UBSAN)
  # -fno-sanitize-recover was deprecated, see if we are compiling with a newer
  # clang that requires -fno-sanitize-recover=all.
  set(UBSAN_BLACKLIST ${WABT_SOURCE_DIR}/ubsan.blacklist)
  include(CheckCXXCompilerFlag)
  check_cxx_compiler_flag("-fsanitize=undefined -fno-sanitize-recover -Wall -Werror" HAS_UBSAN_RECOVER_BARE)
  if (HAS_UBSAN_RECOVER_BARE)
    sanitizer(USE_UBSAN "-fsanitize=undefined -fno-sanitize-recover -fsanitize-blacklist=${UBSAN_BLACKLIST}")
  endif ()
  check_cxx_compiler_flag("-fsanitize=undefined -fno-sanitize-recover=all -Wall -Werror" HAS_UBSAN_RECOVER_ALL)
  if (HAS_UBSAN_RECOVER_ALL)
    sanitizer(USE_UBSAN "-fsanitize=undefined -fno-sanitize-recover=all -fsanitize-blacklist=${UBSAN_BLACKLIST}")
  endif ()
  if (NOT USE_SANITIZER)
    message(FATAL_ERROR "UBSAN is not supported")
  endif ()
endif ()

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${WABT_SOURCE_DIR}/cmake)

add_custom_target(everything)

set(WABT_LIBRARY_SRC
  src/apply-names.h
  src/apply-names.cc
  src/binary.h
  src/binary.cc
  src/binary-reader.h
  src/binary-reader.cc
  src/binary-reader-ir.h
  src/binary-reader-ir.cc
  src/binary-reader-logging.h
  src/binary-reader-logging.cc
  src/binary-writer.h
  src/binary-writer.cc
  src/binary-writer-spec.h
  src/binary-writer-spec.cc
  src/binding-hash.h
  src/binding-hash.cc
  src/color.h
  src/color.cc
  src/common.h
  src/common.cc
  src/config.h
  src/config.cc
  src/decompiler.h
  src/decompiler-ast.h
  src/decompiler-ls.h
  src/decompiler-naming.h
  src/decompiler.cc
  src/error-formatter.h
  src/error-formatter.cc
  src/expr-visitor.h
  src/expr-visitor.cc
  src/feature.h
  src/feature.cc
  src/filenames.h
  src/filenames.cc
  src/generate-names.h
  src/generate-names.cc
  src/hash-util.h
  src/hash-util.cc
  src/ir.h
  src/ir.cc
  src/ir-util.h
  src/ir-util.cc
  src/leb128.h
  src/leb128.cc
  src/lexer-source.h
  src/lexer-source.cc
  src/lexer-source-line-finder.h
  src/lexer-source-line-finder.cc
  src/literal.h
  src/literal.cc
  src/opcode.h
  src/opcode.cc
  src/opcode-code-table.h
  src/opcode-code-table.c
  src/option-parser.h
  src/option-parser.cc
  src/resolve-names.h
  src/resolve-names.cc
  src/shared-validator.h
  src/shared-validator.cc
  src/stream.h
  src/stream.cc
  src/string-view.h
  src/string-view.cc
  src/token.h
  src/token.cc
  src/tracing.h
  src/tracing.cc
  src/type.h
  src/type-checker.h
  src/type-checker.cc
  src/utf8.h
  src/utf8.cc
  src/validator.h
  src/validator.cc
  src/wast-lexer.h
  src/wast-lexer.cc
  src/wast-parser.h
  src/wast-parser.cc
  src/wat-writer.h
  src/wat-writer.cc

  # TODO(binji): Move this into its own library?
  src/interp/binary-reader-interp.h
  src/interp/binary-reader-interp.cc
  src/interp/interp.h
  src/interp/interp.cc
  src/interp/interp-inl.h
  src/interp/interp-math.h
  src/interp/interp-util.h
  src/interp/interp-util.cc
  src/interp/istream.h
  src/interp/istream.cc
)

add_library(wabt STATIC ${WABT_LIBRARY_SRC})

# libwasm, which implenents the wasm C API
if (BUILD_LIBWASM)
  add_library(wasm SHARED ${WABT_LIBRARY_SRC} src/interp/interp-wasm-c-api.cc)
  target_link_libraries(wasm wabt)
  target_include_directories(wasm PUBLIC third_party/wasm-c-api/include)
  if (COMPILER_IS_MSVC)
    target_compile_definitions(wasm PRIVATE "WASM_API_EXTERN=__declspec(dllexport)")
  else ()
    target_compile_options(wasm PRIVATE -Wno-old-style-cast)
    target_compile_definitions(wasm PRIVATE "WASM_API_EXTERN=__attribute__((visibility(\"default\")))")
  endif ()
  set_target_properties(wasm PROPERTIES CXX_VISIBILITY_PRESET hidden)
endif ()

if (NOT EMSCRIPTEN)
  if (CODE_COVERAGE)
    add_definitions("-fprofile-arcs -ftest-coverage")
    if (COMPILER_IS_CLANG)
      set(CMAKE_EXE_LINKER_FLAGS "--coverage")
    else ()
      link_libraries(gcov)
    endif ()
  endif ()

  include(CMakeParseArguments)
  function(wabt_executable)
    cmake_parse_arguments(EXE "WITH_LIBM;INSTALL" "NAME" "SOURCES;LIBS" ${ARGN})

    # Always link libwabt.
    set(EXE_LIBS "${EXE_LIBS};wabt")

    # Optionally link libm.
    if (EXE_WITH_LIBM AND (COMPILER_IS_CLANG OR COMPILER_IS_GNU))
      set(EXE_LIBS "${EXE_LIBS};m")
    endif ()

    add_executable(${EXE_NAME} ${EXE_SOURCES})
    add_dependencies(everything ${EXE_NAME})
    target_link_libraries(${EXE_NAME} ${EXE_LIBS})
    set_property(TARGET ${EXE_NAME} PROPERTY CXX_STANDARD 11)
    set_property(TARGET ${EXE_NAME} PROPERTY CXX_STANDARD_REQUIRED ON)

    if (EXE_INSTALL)
      list(APPEND WABT_EXECUTABLES ${EXE_NAME})
      set(WABT_EXECUTABLES ${WABT_EXECUTABLES} PARENT_SCOPE)

      add_custom_target(${EXE_NAME}-copy-to-bin ALL
        COMMAND ${CMAKE_COMMAND} -E make_directory ${WABT_SOURCE_DIR}/bin
        COMMAND ${CMAKE_COMMAND} -E copy $<TARGET_FILE:${EXE_NAME}> ${WABT_SOURCE_DIR}/bin
        DEPENDS ${EXE_NAME}
      )
    endif ()
  endfunction()

  if (BUILD_TOOLS)
    # wat2wasm
    wabt_executable(
      NAME wat2wasm
      SOURCES src/tools/wat2wasm.cc
      INSTALL
    )

    # wast2json
    wabt_executable(
      NAME wast2json
      SOURCES src/tools/wast2json.cc

=== debian/changelog ===
wabt (1.0.16-1) unstable; urgency=medium

  * New upstream version 1.0.16.

 -- Markus Koschany <apo@debian.org>  Thu, 28 May 2020 22:35:04 +0200

## wabt 1.0.17

=== CMakeLists.txt ===
--- 
+++ 
@@ -342,55 +342,62 @@
   set_target_properties(wasm PROPERTIES CXX_VISIBILITY_PRESET hidden)
 endif ()
 
-if (NOT EMSCRIPTEN)
-  if (CODE_COVERAGE)
-    add_definitions("-fprofile-arcs -ftest-coverage")
-    if (COMPILER_IS_CLANG)
-      set(CMAKE_EXE_LINKER_FLAGS "--coverage")
-    else ()
-      link_libraries(gcov)
-    endif ()
-  endif ()
-
-  include(CMakeParseArguments)
-  function(wabt_executable)
-    cmake_parse_arguments(EXE "WITH_LIBM;INSTALL" "NAME" "SOURCES;LIBS" ${ARGN})
-
-    # Always link libwabt.
-    set(EXE_LIBS "${EXE_LIBS};wabt")
-
-    # Optionally link libm.
-    if (EXE_WITH_LIBM AND (COMPILER_IS_CLANG OR COMPILER_IS_GNU))
-      set(EXE_LIBS "${EXE_LIBS};m")
-    endif ()
-
-    add_executable(${EXE_NAME} ${EXE_SOURCES})
-    add_dependencies(everything ${EXE_NAME})
-    target_link_libraries(${EXE_NAME} ${EXE_LIBS})
-    set_property(TARGET ${EXE_NAME} PROPERTY CXX_STANDARD 11)
-    set_property(TARGET ${EXE_NAME} PROPERTY CXX_STANDARD_REQUIRED ON)
-
-    if (EXE_INSTALL)
-      list(APPEND WABT_EXECUTABLES ${EXE_NAME})
-      set(WABT_EXECUTABLES ${WABT_EXECUTABLES} PARENT_SCOPE)
-
-      add_custom_target(${EXE_NAME}-copy-to-bin ALL
-        COMMAND ${CMAKE_COMMAND} -E make_directory ${WABT_SOURCE_DIR}/bin
-        COMMAND ${CMAKE_COMMAND} -E copy $<TARGET_FILE:${EXE_NAME}> ${WABT_SOURCE_DIR}/bin
-        DEPENDS ${EXE_NAME}
-      )
-    endif ()
-  endfunction()
-
-  if (BUILD_TOOLS)
-    # wat2wasm
-    wabt_executable(
-      NAME wat2wasm
-      SOURCES src/tools/wat2wasm.cc
-      INSTALL
+if (CODE_COVERAGE)
+  add_definitions("-fprofile-arcs -ftest-coverage")
+  if (COMPILER_IS_CLANG)
+    set(CMAKE_EXE_LINKER_FLAGS "--coverage")
+  else ()
+    link_libraries(gcov)
+  endif ()
+endif ()
+
+include(CMakeParseArguments)
+function(wabt_executable)
+  cmake_parse_arguments(EXE "WITH_LIBM;INSTALL" "NAME" "SOURCES;LIBS" ${ARGN})
+
+  # Always link libwabt.
+  set(EXE_LIBS "${EXE_LIBS};wabt")
+
+  # Optionally link libm.
+  if (EXE_WITH_LIBM AND (COMPILER_IS_CLANG OR COMPILER_IS_GNU))
+    set(EXE_LIBS "${EXE_LIBS};m")
+  endif ()
+
+  add_executable(${EXE_NAME} ${EXE_SOURCES})
+  add_dependencies(everything ${EXE_NAME})
+  target_link_libraries(${EXE_NAME} ${EXE_LIBS})
+  set_property(TARGET ${EXE_NAME} PROPERTY CXX_STANDARD 11)
+  set_property(TARGET ${EXE_NAME} PROPERTY CXX_STANDARD_REQUIRED ON)
+
+  if (EXE_INSTALL)
+    list(APPEND WABT_EXECUTABLES ${EXE_NAME})
+    set(WABT_EXECUTABLES ${WABT_EXECUTABLES} PARENT_SCOPE)
+
+    add_custom_target(${EXE_NAME}-copy-to-bin ALL
+      COMMAND ${CMAKE_COMMAND} -E make_directory ${WABT_SOURCE_DIR}/bin
+      COMMAND ${CMAKE_COMMAND} -E copy $<TARGET_FILE:${EXE_NAME}> ${WABT_SOURCE_DIR}/bin
+      DEPENDS ${EXE_NAME}
     )
-
-    # wast2json
-    wabt_executable(
-      NAME wast2json
-      SOURCES src/tools/wast2json.cc
+  endif ()
+endfunction()
+
+if (BUILD_TOOLS)
+  # wat2wasm
+  wabt_executable(
+    NAME wat2wasm
+    SOURCES src/tools/wat2wasm.cc
+    INSTALL
+  )
+
+  # wast2json
+  wabt_executable(
+    NAME wast2json
+    SOURCES src/tools/wast2json.cc
+    INSTALL
+  )
+
+  # wasm2wat
+  wabt_executable(
+    NAME wasm2wat
+    SOURCES src/tools/wasm2wat.cc
+    INSTALL

=== debian/changelog ===
wabt (1.0.17-1) unstable; urgency=medium

  * New upstream version 1.0.17.

 -- Markus Koschany <apo@debian.org>  Tue, 30 Jun 2020 21:45:57 +0200

## wabt 1.0.19

=== CMakeLists.txt ===
--- 
+++ 
@@ -17,7 +17,17 @@
 cmake_minimum_required(VERSION 3.0.0)
 project(WABT VERSION 1.0.13)
 
+if (POLICY CMP0077)
+  cmake_policy(SET CMP0077 NEW)
+endif (POLICY CMP0077)
+
 set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
+
+# Check if wabt is being used directly or via add_subdirectory, FetchContent, etc
+set(WABT_MASTER_PROJECT OFF)
+if (CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
+  set(WABT_MASTER_PROJECT ON)
+endif()
 
 # For git users, attempt to generate a more useful version string
 if (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/.git)
@@ -26,11 +36,17 @@
           "${GIT_EXECUTABLE}" --git-dir=${CMAKE_CURRENT_SOURCE_DIR}/.git describe --tags
           RESULT_VARIABLE
               GIT_VERSION_RESULT
+          ERROR_VARIABLE
+              GIT_VERSION_ERROR
           OUTPUT_VARIABLE
               GIT_VERSION
           OUTPUT_STRIP_TRAILING_WHITESPACE)
   if (${GIT_VERSION_RESULT})
-    message(WARNING "Error running git describe to determine version")
+    # Don't issue warning if we aren't the master project;
+    # just assume that whoever included us knows the version they are getting
+    if (WABT_MASTER_PROJECT)
+      message(WARNING "${GIT_VERSION_ERROR} Error running git describe to determine version")
+    endif()
   else ()
     set(CMAKE_PROJECT_VERSION "${CMAKE_PROJECT_VERSION} (${GIT_VERSION})")
   endif ()
@@ -369,35 +385,7 @@
   set_property(TARGET ${EXE_NAME} PROPERTY CXX_STANDARD 11)
   set_property(TARGET ${EXE_NAME} PROPERTY CXX_STANDARD_REQUIRED ON)
 
-  if (EXE_INSTALL)
-    list(APPEND WABT_EXECUTABLES ${EXE_NAME})
-    set(WABT_EXECUTABLES ${WABT_EXECUTABLES} PARENT_SCOPE)
-
-    add_custom_target(${EXE_NAME}-copy-to-bin ALL
-      COMMAND ${CMAKE_COMMAND} -E make_directory ${WABT_SOURCE_DIR}/bin
-      COMMAND ${CMAKE_COMMAND} -E copy $<TARGET_FILE:${EXE_NAME}> ${WABT_SOURCE_DIR}/bin
-      DEPENDS ${EXE_NAME}
-    )
-  endif ()
-endfunction()
-
-if (BUILD_TOOLS)
-  # wat2wasm
-  wabt_executable(
-    NAME wat2wasm
-    SOURCES src/tools/wat2wasm.cc
-    INSTALL
-  )
-
-  # wast2json
-  wabt_executable(
-    NAME wast2json
-    SOURCES src/tools/wast2json.cc
-    INSTALL
-  )
-
-  # wasm2wat
-  wabt_executable(
-    NAME wasm2wat
-    SOURCES src/tools/wasm2wat.cc
-    INSTALL
+  if (EMSCRIPTEN)
+    # build to JS for now, as node.js doesn't have code caching for wasm yet,
+    # and wasm startup times are slower
+    set_target_properties(${EXE_NAME}

=== Makefile ===
#
# Copyright 2016 WebAssembly Community Group participants
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

.SUFFIXES:

MAKEFILE_NAME := $(lastword $(MAKEFILE_LIST))
ROOT_DIR := $(dir $(abspath $(MAKEFILE_NAME)))

USE_NINJA ?= 0
FUZZ_BIN_DIR ?= ${ROOT_DIR}/afl-fuzz
GCC_FUZZ_CC := ${FUZZ_BIN_DIR}/afl-gcc
GCC_FUZZ_CXX := ${FUZZ_BIN_DIR}/afl-g++
EMSCRIPTEN_DIR ?= $(dir $(shell which emcc))
CMAKE_CMD ?= cmake

DEFAULT_SUFFIX = clang-debug

COMPILERS := GCC GCC_I686 GCC_FUZZ CLANG CLANG_I686 EMCC
BUILD_TYPES := DEBUG RELEASE
SANITIZERS := ASAN MSAN LSAN UBSAN
CONFIGS := NORMAL $(SANITIZERS) COV NO_TESTS

# directory names
GCC_DIR := gcc/
GCC_I686_DIR := gcc-i686/
GCC_FUZZ_DIR := gcc-fuzz/
CLANG_DIR := clang/
CLANG_I686_DIR := clang-i686/
EMCC_DIR := emscripten/
DEBUG_DIR := Debug/
RELEASE_DIR := Release/
NORMAL_DIR :=
ASAN_DIR := asan/
MSAN_DIR := msan/
LSAN_DIR := lsan/
UBSAN_DIR := ubsan/
COV_DIR := cov/
NO_TESTS_DIR := no-tests/

# CMake flags
GCC_FLAG := -DCMAKE_C_COMPILER=gcc -DCMAKE_CXX_COMPILER=g++
GCC_I686_FLAG := -DCMAKE_C_COMPILER=gcc -DCMAKE_CXX_COMPILER=g++ \
	-DCMAKE_C_FLAGS=-m32 -DCMAKE_CXX_FLAGS=-m32
GCC_FUZZ_FLAG := -DCMAKE_C_COMPILER=${GCC_FUZZ_CC} -DCMAKE_CXX_COMPILER=${GCC_FUZZ_CXX} -DWITH_EXCEPTIONS=ON
CLANG_FLAG := -DCMAKE_C_COMPILER=clang -DCMAKE_CXX_COMPILER=clang++
CLANG_I686_FLAG := -DCMAKE_C_COMPILER=clang -DCMAKE_CXX_COMPILER=clang++ \
	-DCMAKE_C_FLAGS=-m32 -DCMAKE_CXX_FLAGS=-m32
EMCC_FLAG := -DCMAKE_TOOLCHAIN_FILE=${EMSCRIPTEN_DIR}/cmake/Modules/Platform/Emscripten.cmake
DEBUG_FLAG := -DCMAKE_BUILD_TYPE=Debug
RELEASE_FLAG := -DCMAKE_BUILD_TYPE=Release
NORMAL_FLAG :=
ASAN_FLAG := -DUSE_ASAN=ON
MSAN_FLAG := -DUSE_MSAN=ON
LSAN_FLAG := -DUSE_LSAN=ON
UBSAN_FLAG := -DUSE_UBSAN=ON
COV_FLAG := -DCODE_COVERAGE=ON
NO_TESTS_FLAG := -DBUILD_TESTS=OFF

# make target prefixes
GCC_PREFIX := gcc
GCC_I686_PREFIX := gcc-i686
GCC_FUZZ_PREFIX := gcc-fuzz
CLANG_PREFIX := clang
CLANG_I686_PREFIX := clang-i686
EMCC_PREFIX := emscripten
DEBUG_PREFIX := -debug
RELEASE_PREFIX := -release
NORMAL_PREFIX :=
ASAN_PREFIX := -asan
MSAN_PREFIX := -msan
LSAN_PREFIX := -lsan
UBSAN_PREFIX := -ubsan
COV_PREFIX := -cov
NO_TESTS_PREFIX := -no-tests

ifeq ($(USE_NINJA),1)
BUILD_CMD := ninja
BUILD_FILE := build.ninja
GENERATOR := Ninja
else
BUILD_CMD := +$(MAKE) --no-print-directory
BUILD_FILE := Makefile
GENERATOR := "Unix Makefiles"
endif

CMAKE_DIR = out/$($(1)_DIR)$($(2)_DIR)$($(3)_DIR)
BUILD_TARGET = $($(1)_PREFIX)$($(2)_PREFIX)$($(3)_PREFIX)
INSTALL_TARGET = install-$($(1)_PREFIX)$($(2)_PREFIX)$($(3)_PREFIX)
TEST_TARGET = test-$($(1)_PREFIX)$($(2)_PREFIX)$($(3)_PREFIX)

define CMAKE
$(call CMAKE_DIR,$(1),$(2),$(3)):
	mkdir -p $(call CMAKE_DIR,$(1),$(2),$(3))

$(call CMAKE_DIR,$(1),$(2),$(3))$$(BUILD_FILE): | $(call CMAKE_DIR,$(1),$(2),$(3))
	cd $(call CMAKE_DIR,$(1),$(2),$(3)) && \
	$$(CMAKE_CMD) -G $$(GENERATOR) $$(ROOT_DIR) $$($(1)_FLAG) $$($(2)_FLAG) $$($(3)_FLAG)
endef

define BUILD
.PHONY: $(call BUILD_TARGET,$(1),$(2),$(3))
$(call BUILD_TARGET,$(1),$(2),$(3)): $(call CMAKE_DIR,$(1),$(2),$(3))$$(BUILD_FILE)
	$$(BUILD_CMD) -C $(call CMAKE_DIR,$(1),$(2),$(3)) all
endef

define INSTALL
.PHONY: $(call INSTALL_TARGET,$(1),$(2),$(3))
$(call INSTALL_TARGET,$(1),$(2),$(3)): $(call CMAKE_DIR,$(1),$(2),$(3))$$(BUILD_FILE)
	$$(BUILD_CMD) -C $(call CMAKE_DIR,$(1),$(2),$(3)) install
endef

define TEST
.PHONY: $(call TEST_TARGET,$(1),$(2),$(3))
$(call TEST_TARGET,$(1),$(2),$(3)): $(call CMAKE_DIR,$(1),$(2),$(3))$$(BUILD_FILE)
	$$(BUILD_CMD) -C $(call CMAKE_DIR,$(1),$(2),$(3)) check
test-everything: $(CALL TEST_TARGET,$(1),$(2),$(3))
endef

.PHONY: all install test
all: $(DEFAULT_SUFFIX)
install: install-$(DEFAULT_SUFFIX)
test: test-$(DEFAULT_SUFFIX)

.PHONY: clean
clean:
	rm -rf out

.PHONY: test-everything
test-everything:

.PHONY: update-gperf
update-gperf: src/prebuilt/lexer-keywords.cc

src/prebuilt/lexer-keywords.cc: src/lexer-keywords.txt
	gperf -m 50 -L C++ -N InWordSet -E -t -c --output-file=$@ $<

.PHONY: update-wasm2c
update-wasm2c: src/prebuilt/wasm2c.include.c src/prebuilt/wasm2c.include.h

src/prebuilt/wasm2c.include.c: src/wasm2c.c.tmpl
	src/wasm2c_tmpl.py -o $@ $<

src/prebuilt/wasm2c.include.h: src/wasm2c.h.tmpl
	src/wasm2c_tmpl.py -o $@ $<

.PHONY: demo
demo: emscripten-release
	cp out/emscripten/Release/libwabt.js docs/demo

# running CMake
$(foreach CONFIG,$(CONFIGS), \
	$(foreach COMPILER,$(COMPILERS), \
		$(foreach BUILD_TYPE,$(BUILD_TYPES), \
			$(eval $(call CMAKE,$(COMPILER),$(BUILD_TYPE),$(CONFIG))))))

# building
$(foreach CONFIG,$(CONFIGS), \
	$(foreach COMPILER,$(COMPILERS), \
		$(foreach BUILD_TYPE,$(BUILD_TYPES), \
			$(eval $(call BUILD,$(COMPILER),$(BUILD_TYPE),$(CONFIG))))))

# installing
$(foreach CONFIG,$(CONFIGS), \
	$(foreach COMPILER,$(COMPILERS), \
		$(foreach BUILD_TYPE,$(BUILD_TYPES), \
			$(eval $(call INSTALL,$(COMPILER),$(BUILD_TYPE),$(CONFIG))))))

# test running
$(foreach CONFIG,$(CONFIGS), \
	$(foreach COMPILER,$(COMPILERS), \
		$(foreach BUILD_TYPE,$(BUILD_TYPES), \
			$(eval $(call TEST,$(COMPILER),$(BUILD_TYPE),$(CONFIG))))))

=== debian/changelog ===
wabt (1.0.19-1) unstable; urgency=medium

  * New upstream version 1.0.19.

 -- Markus Koschany <apo@debian.org>  Wed, 22 Jul 2020 13:38:30 +0200

## wabt 1.0.20

=== CMakeLists.txt ===
--- 
+++ 
@@ -16,6 +16,7 @@
 
 cmake_minimum_required(VERSION 3.0.0)
 project(WABT VERSION 1.0.13)
+include(GNUInstallDirs)
 
 if (POLICY CMP0077)
   cmake_policy(SET CMP0077 NEW)
@@ -52,9 +53,14 @@
   endif ()
 endif ()
 
+if (NOT "${CMAKE_PROJECT_VERSION}")
+  set(CMAKE_PROJECT_VERSION ${PROJECT_VERSION})
+endif()
+
 option(BUILD_TESTS "Build GTest-based tests" ON)
 option(USE_SYSTEM_GTEST "Use system GTest, instead of building" OFF)
 option(BUILD_TOOLS "Build wabt commandline tools" ON)
+option(BUILD_FUZZ_TOOLS "Build tools that can repro fuzz bugs" OFF)
 option(BUILD_LIBWASM "Build libwasm" ON)
 option(USE_ASAN "Use address sanitizer" OFF)
 option(USE_MSAN "Use memory sanitizer" OFF)
@@ -120,14 +126,14 @@
   # disable warning C4800: implicit conversion from larger int to bool
   add_definitions(-W3 -wd4018 -wd4056 -wd4756 -wd4267 -wd4244 -wd4800 -D_CRT_SECURE_NO_WARNINGS -D_SCL_SECURE_NO_WARNINGS)
 
-  if (WERROR)
-    add_definitions(-WX)
-  endif ()
-
   if (NOT WITH_EXCEPTIONS)
     # disable exception use in C++ library
     add_definitions(-D_HAS_EXCEPTIONS=0)
   endif ()
+
+  # multi-core build.
+  add_definitions("/MP")
+
 else ()
   # disable -Wunused-parameter: this is really common when implementing
   #   interfaces, etc.
@@ -139,10 +145,6 @@
 
   set(CMAKE_CXX_EXTENSIONS OFF)
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Wold-style-cast")
-
-  if (WERROR)
-    add_definitions(-Werror)
-  endif ()
 
   if (NOT WITH_EXCEPTIONS)
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-exceptions")
@@ -344,15 +346,36 @@
 
 add_library(wabt STATIC ${WABT_LIBRARY_SRC})
 
+IF (NOT WIN32)
+  add_library(wasm-rt-impl STATIC wasm2c/wasm-rt-impl.c wasm2c/wasm-rt-impl.h)
+  install(TARGETS wasm-rt-impl DESTINATION ${CMAKE_INSTALL_LIBDIR})
+  install(FILES wasm2c/wasm-rt.h wasm2c/wasm-rt-impl.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
+endif ()
+
+if (BUILD_FUZZ_TOOLS)
+  set(FUZZ_FLAGS "-fsanitize=fuzzer,address")
+  add_library(wabt-fuzz STATIC ${WABT_LIBRARY_SRC})
+  set_target_properties(wabt-fuzz
+    PROPERTIES
+    COMPILE_FLAGS "${FUZZ_FLAGS}"
+  )
+endif ()
+
 # libwasm, which implenents the wasm C API
 if (BUILD_LIBWASM)
   add_library(wasm SHARED ${WABT_LIBRARY_SRC} src/interp/interp-wasm-c-api.cc)
   target_link_libraries(wasm wabt)
   target_include_directories(wasm PUBLIC third_party/wasm-c-api/include)
   if (COMPILER_IS_MSVC)
+    if (WERROR)
+      target_compile_options(wasm PRIVATE -WX)
+    endif ()
     target_compile_definitions(wasm PRIVATE "WASM_API_EXTERN=__declspec(dllexport)")
   else ()
-    target_compile_options(wasm PRIVATE -Wno-old-style-cast)
+    if (WERROR)
+      target_compile_options(wasm PRIVATE -Werror)
+    endif ()
+    target_compile_options(wasm PRIVATE $<$<COMPILE_LANGUAGE:CXX>:-Wno-old-style-cast>)
     target_compile_definitions(wasm PRIVATE "WASM_API_EXTERN=__attribute__((visibility(\"default\")))")
   endif ()
   set_target_properties(wasm PROPERTIES CXX_VISIBILITY_PRESET hidden)
@@ -363,29 +386,3 @@
   if (COMPILER_IS_CLANG)
     set(CMAKE_EXE_LINKER_FLAGS "--coverage")
   else ()
-    link_libraries(gcov)
-  endif ()
-endif ()
-
-include(CMakeParseArguments)
-function(wabt_executable)
-  cmake_parse_arguments(EXE "WITH_LIBM;INSTALL" "NAME" "SOURCES;LIBS" ${ARGN})
-
-  # Always link libwabt.
-  set(EXE_LIBS "${EXE_LIBS};wabt")
-
-  # Optionally link libm.
-  if (EXE_WITH_LIBM AND (COMPILER_IS_CLANG OR COMPILER_IS_GNU))
-    set(EXE_LIBS "${EXE_LIBS};m")
-  endif ()
-
-  add_executable(${EXE_NAME} ${EXE_SOURCES})
-  add_dependencies(everything ${EXE_NAME})
-  target_link_libraries(${EXE_NAME} ${EXE_LIBS})
-  set_property(TARGET ${EXE_NAME} PROPERTY CXX_STANDARD 11)
-  set_property(TARGET ${EXE_NAME} PROPERTY CXX_STANDARD_REQUIRED ON)
-
-  if (EMSCRIPTEN)
-    # build to JS for now, as node.js doesn't have code caching for wasm yet,
-    # and wasm startup times are slower
-    set_target_properties(${EXE_NAME}

=== Makefile ===
--- 
+++ 
@@ -20,23 +20,19 @@
 ROOT_DIR := $(dir $(abspath $(MAKEFILE_NAME)))
 
 USE_NINJA ?= 0
-FUZZ_BIN_DIR ?= ${ROOT_DIR}/afl-fuzz
-GCC_FUZZ_CC := ${FUZZ_BIN_DIR}/afl-gcc
-GCC_FUZZ_CXX := ${FUZZ_BIN_DIR}/afl-g++
 EMSCRIPTEN_DIR ?= $(dir $(shell which emcc))
 CMAKE_CMD ?= cmake
 
 DEFAULT_SUFFIX = clang-debug
 
-COMPILERS := GCC GCC_I686 GCC_FUZZ CLANG CLANG_I686 EMCC
+COMPILERS := GCC GCC_I686 CLANG CLANG_I686 EMCC
 BUILD_TYPES := DEBUG RELEASE
-SANITIZERS := ASAN MSAN LSAN UBSAN
+SANITIZERS := ASAN MSAN LSAN UBSAN FUZZ
 CONFIGS := NORMAL $(SANITIZERS) COV NO_TESTS
 
 # directory names
 GCC_DIR := gcc/
 GCC_I686_DIR := gcc-i686/
-GCC_FUZZ_DIR := gcc-fuzz/
 CLANG_DIR := clang/
 CLANG_I686_DIR := clang-i686/
 EMCC_DIR := emscripten/
@@ -47,6 +43,7 @@
 MSAN_DIR := msan/
 LSAN_DIR := lsan/
 UBSAN_DIR := ubsan/
+FUZZ_DIR := fuzz/
 COV_DIR := cov/
 NO_TESTS_DIR := no-tests/
 
@@ -54,10 +51,8 @@
 GCC_FLAG := -DCMAKE_C_COMPILER=gcc -DCMAKE_CXX_COMPILER=g++
 GCC_I686_FLAG := -DCMAKE_C_COMPILER=gcc -DCMAKE_CXX_COMPILER=g++ \
 	-DCMAKE_C_FLAGS=-m32 -DCMAKE_CXX_FLAGS=-m32
-GCC_FUZZ_FLAG := -DCMAKE_C_COMPILER=${GCC_FUZZ_CC} -DCMAKE_CXX_COMPILER=${GCC_FUZZ_CXX} -DWITH_EXCEPTIONS=ON
 CLANG_FLAG := -DCMAKE_C_COMPILER=clang -DCMAKE_CXX_COMPILER=clang++
 CLANG_I686_FLAG := -DCMAKE_C_COMPILER=clang -DCMAKE_CXX_COMPILER=clang++ \
-	-DCMAKE_C_FLAGS=-m32 -DCMAKE_CXX_FLAGS=-m32
 EMCC_FLAG := -DCMAKE_TOOLCHAIN_FILE=${EMSCRIPTEN_DIR}/cmake/Modules/Platform/Emscripten.cmake
 DEBUG_FLAG := -DCMAKE_BUILD_TYPE=Debug
 RELEASE_FLAG := -DCMAKE_BUILD_TYPE=Release
@@ -66,13 +61,13 @@
 MSAN_FLAG := -DUSE_MSAN=ON
 LSAN_FLAG := -DUSE_LSAN=ON
 UBSAN_FLAG := -DUSE_UBSAN=ON
+FUZZ_FLAG := -DBUILD_FUZZ_TOOLS=ON
 COV_FLAG := -DCODE_COVERAGE=ON
 NO_TESTS_FLAG := -DBUILD_TESTS=OFF
 
 # make target prefixes
 GCC_PREFIX := gcc
 GCC_I686_PREFIX := gcc-i686
-GCC_FUZZ_PREFIX := gcc-fuzz
 CLANG_PREFIX := clang
 CLANG_I686_PREFIX := clang-i686
 EMCC_PREFIX := emscripten
@@ -83,6 +78,7 @@
 MSAN_PREFIX := -msan
 LSAN_PREFIX := -lsan
 UBSAN_PREFIX := -ubsan
+FUZZ_PREFIX := -fuzz
 COV_PREFIX := -cov
 NO_TESTS_PREFIX := -no-tests

=== wasm2c/examples/rot13/Makefile ===
# Use implicit rules for compiling C files.
CFLAGS=-I../..
rot13: main.o rot13.o ../../wasm-rt-impl.o

rot13.wasm: rot13.wat
	../../../bin/wat2wasm $< -o $@

rot13.c: rot13.wasm
	../../../bin/wasm2c $< -o $@

=== debian/changelog ===
wabt (1.0.20-1) unstable; urgency=medium

  * New upstream version 1.0.20.

 -- Markus Koschany <apo@debian.org>  Wed, 11 Nov 2020 12:39:22 +0100

=== debian/control ===
Source: wabt
Section: devel
Priority: optional
Maintainer: Markus Koschany <apo@debian.org>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 python3,
 re2c
Standards-Version: 4.5.0
Homepage: https://github.com/WebAssembly/wabt
Vcs-Git: https://salsa.debian.org/debian/wabt.git
Vcs-Browser: https://salsa.debian.org/debian/wabt

Package: wabt
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: WebAssembly Binary Toolkit
 WABT (pronounced: "wabbit") is a suite of tools for WebAssembly, including:
 .
  * wat2wasm: translate from WebAssembly text format to the WebAssembly binary
    format
  * wasm2wat: the inverse of wat2wasm, translate from the binary format back
    to the text format (also known as a .wat)
  * wasm-objdump: print information about a wasm binary. Similar to objdump.
  * wasm-interp: decode and run a WebAssembly binary file using a stack-based
    interpreter
  * wat-desugar: parse .wat text form as supported by the spec interpreter
    (s-expressions, flat syntax, or mixed) and print "canonical" flat format
  * wasm2c: convert a WebAssembly binary file to a C source and header
 .
 These tools are intended for use in (or for development of) toolchains or
 other systems that want to manipulate WebAssembly files. Unlike the
 WebAssembly spec interpreter (which is written to be as simple, declarative
 and "speccy" as possible), they are written in C/C++ and designed for easier
 integration into other systems. Unlike Binaryen these tools do not aim to
 provide an optimization platform or a higher-level compiler target; instead
 they aim for full fidelity and compliance with the spec (e.g. 1:1 round-trips
 with no changes to instructions).

## wabt 1.0.24

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
 #
 
 cmake_minimum_required(VERSION 3.0.0)
-project(WABT VERSION 1.0.13)
+project(WABT VERSION 1.0.24)
 include(GNUInstallDirs)
 
 if (POLICY CMP0077)
@@ -139,8 +139,7 @@
   #   interfaces, etc.
   # disable -Wpointer-arith: this is a GCC extension, and doesn't work in MSVC.
   add_definitions(
-    -Wall -Wextra -Wno-unused-parameter -Wpointer-arith -g
-    -Wuninitialized
+    -Wall -Wextra -Wno-unused-parameter -Wpointer-arith -Wuninitialized
   )
 
   set(CMAKE_CXX_EXTENSIONS OFF)
@@ -192,6 +191,8 @@
           set(TARGET_ARCH "i386")
         elseif (${FILE_OUTPUT} MATCHES "ARM")
           set(TARGET_ARCH "ARM")
+        elseif (${FILE_OUTPUT} MATCHES "IBM S/390")
+          set(TARGET_ARCH "s390x")
         else ()
           message(WARNING "Unknown target architecture!")
         endif ()
@@ -206,6 +207,9 @@
       # wasm doesn't allow for x87 floating point math
       add_definitions(-msse2 -mfpmath=sse)
     endif ()
+    if (TARGET_ARCH STREQUAL "s390x")
+      add_definitions(-DWABT_BIG_ENDIAN=1)
+    endif ()
   endif ()
 endif ()
 
@@ -235,7 +239,8 @@
     sanitizer(USE_UBSAN "-fsanitize=undefined -fno-sanitize-recover -fsanitize-blacklist=${UBSAN_BLACKLIST}")
   endif ()
   check_cxx_compiler_flag("-fsanitize=undefined -fno-sanitize-recover=all -Wall -Werror" HAS_UBSAN_RECOVER_ALL)
-  if (HAS_UBSAN_RECOVER_ALL)
+  # If we already setup UBSAN recover bare, setting it up again here will be an error.
+  if (NOT USE_SANITIZER AND HAS_UBSAN_RECOVER_ALL)
     sanitizer(USE_UBSAN "-fsanitize=undefined -fno-sanitize-recover=all -fsanitize-blacklist=${UBSAN_BLACKLIST}")
   endif ()
   if (NOT USE_SANITIZER)
@@ -376,13 +381,3 @@
       target_compile_options(wasm PRIVATE -Werror)
     endif ()
     target_compile_options(wasm PRIVATE $<$<COMPILE_LANGUAGE:CXX>:-Wno-old-style-cast>)
-    target_compile_definitions(wasm PRIVATE "WASM_API_EXTERN=__attribute__((visibility(\"default\")))")
-  endif ()
-  set_target_properties(wasm PROPERTIES CXX_VISIBILITY_PRESET hidden)
-endif ()
-
-if (CODE_COVERAGE)
-  add_definitions("-fprofile-arcs -ftest-coverage")
-  if (COMPILER_IS_CLANG)
-    set(CMAKE_EXE_LINKER_FLAGS "--coverage")
-  else ()

=== debian/changelog ===
wabt (1.0.24-1) unstable; urgency=medium

  * New upstream version 1.0.24.
  * Declare compliance with Debian Policy 4.6.0.

 -- Markus Koschany <apo@debian.org>  Thu, 19 Aug 2021 13:04:10 +0200

wabt (1.0.21-1) experimental; urgency=medium

  * New upstream version 1.0.21.
  * Declare compliance with Debian Policy 4.5.1.

 -- Markus Koschany <apo@debian.org>  Sat, 13 Mar 2021 23:22:18 +0100

## wabt 1.0.25

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
 #
 
 cmake_minimum_required(VERSION 3.0.0)
-project(WABT VERSION 1.0.24)
+project(WABT VERSION 1.0.25)
 include(GNUInstallDirs)
 
 if (POLICY CMP0077)

=== Makefile ===
--- 
+++ 
@@ -19,7 +19,7 @@
 MAKEFILE_NAME := $(lastword $(MAKEFILE_LIST))
 ROOT_DIR := $(dir $(abspath $(MAKEFILE_NAME)))
 
-USE_NINJA ?= 0
+USE_NINJA ?= 1
 EMSCRIPTEN_DIR ?= $(dir $(shell which emcc))
 CMAKE_CMD ?= cmake
 
@@ -53,6 +53,7 @@
 	-DCMAKE_C_FLAGS=-m32 -DCMAKE_CXX_FLAGS=-m32
 CLANG_FLAG := -DCMAKE_C_COMPILER=clang -DCMAKE_CXX_COMPILER=clang++
 CLANG_I686_FLAG := -DCMAKE_C_COMPILER=clang -DCMAKE_CXX_COMPILER=clang++ \
+	-DCMAKE_C_FLAGS=-m32 -DCMAKE_CXX_FLAGS=-m32
 EMCC_FLAG := -DCMAKE_TOOLCHAIN_FILE=${EMSCRIPTEN_DIR}/cmake/Modules/Platform/Emscripten.cmake
 DEBUG_FLAG := -DCMAKE_BUILD_TYPE=Debug
 RELEASE_FLAG := -DCMAKE_BUILD_TYPE=Release

=== debian/changelog ===
wabt (1.0.25-1) unstable; urgency=medium

  * New upstream version 1.0.25.

 -- Markus Koschany <apo@debian.org>  Sun, 19 Dec 2021 00:42:18 +0100

wabt (1.0.24-2) unstable; urgency=medium

  * Only install the examples and the README file into /usr/share/doc/wabt.
  * Install wasm-rt* files into /usr/src/wasm2c.
    Thanks to Jonas Smedegaard for the report. (Closes: #999872)

 -- Markus Koschany <apo@debian.org>  Fri, 19 Nov 2021 13:58:39 +0100

## wabt 1.0.26

=== debian/changelog ===
wabt (1.0.26-1) unstable; urgency=medium

  * New upstream version 1.0.26.

 -- Markus Koschany <apo@debian.org>  Sun, 06 Feb 2022 22:11:53 +0100

## wabt 1.0.27

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,8 +15,10 @@
 #
 
 cmake_minimum_required(VERSION 3.0.0)
-project(WABT VERSION 1.0.25)
+project(WABT LANGUAGES C CXX VERSION 1.0.27)
 include(GNUInstallDirs)
+
+set(CXX_STANDARD 17)
 
 if (POLICY CMP0077)
   cmake_policy(SET CMP0077 NEW)
@@ -125,6 +127,7 @@
   # disable warnings C4267 and C4244: conversion/truncation from larger to smaller type.
   # disable warning C4800: implicit conversion from larger int to bool
   add_definitions(-W3 -wd4018 -wd4056 -wd4756 -wd4267 -wd4244 -wd4800 -D_CRT_SECURE_NO_WARNINGS -D_SCL_SECURE_NO_WARNINGS)
+  add_definitions(/std:c++${CXX_STANDARD})
 
   if (NOT WITH_EXCEPTIONS)
     # disable exception use in C++ library
@@ -143,7 +146,7 @@
   )
 
   set(CMAKE_CXX_EXTENSIONS OFF)
-  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Wold-style-cast")
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++${CXX_STANDARD} -Wold-style-cast")
 
   if (NOT WITH_EXCEPTIONS)
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-exceptions")
@@ -290,8 +293,6 @@
   src/filenames.cc
   src/generate-names.h
   src/generate-names.cc
-  src/hash-util.h
-  src/hash-util.cc
   src/ir.h
   src/ir.cc
   src/ir-util.h
@@ -316,8 +317,7 @@
   src/shared-validator.cc
   src/stream.h
   src/stream.cc
-  src/string-view.h
-  src/string-view.cc
+  src/string-util.h
   src/token.h
   src/token.cc
   src/tracing.h

=== wasm2c/examples/fac/Makefile ===
# Use implicit rules for compiling C files.
CFLAGS=-I../..
fac: main.o fac.o ../../wasm-rt-impl.o

fac.wasm: fac.wat
	../../../bin/wat2wasm $< -o $@

fac.c: fac.wasm
	../../../bin/wasm2c $< -o $@

=== debian/changelog ===
wabt (1.0.27-1) unstable; urgency=medium

  * New upstream version 1.0.27.

 -- Markus Koschany <apo@debian.org>  Sat, 19 Feb 2022 23:05:06 +0100

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
  debhelper-compat (= 13),
  python3,
  re2c
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Homepage: https://github.com/WebAssembly/wabt
 Vcs-Git: https://salsa.debian.org/debian/wabt.git
 Vcs-Browser: https://salsa.debian.org/debian/wabt

## wabt 1.0.28

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
 #
 
 cmake_minimum_required(VERSION 3.0.0)
-project(WABT LANGUAGES C CXX VERSION 1.0.27)
+project(WABT LANGUAGES C CXX VERSION 1.0.28)
 include(GNUInstallDirs)
 
 set(CXX_STANDARD 17)
@@ -121,6 +121,10 @@
 include_directories(${WABT_SOURCE_DIR} ${WABT_BINARY_DIR})
 
 if (COMPILER_IS_MSVC)
+  if (WERROR)
+    add_definitions(-WX)
+  endif ()
+
   # disable warning C4018: signed/unsigned mismatch
   # disable warning C4056, C4756: overflow in floating-point constant arithmetic
   #   seems to not like float compare w/ HUGE_VALF; bug?
@@ -138,6 +142,10 @@
   add_definitions("/MP")
 
 else ()
+  if (WERROR)
+    add_definitions(-Werror)
+  endif ()
+
   # disable -Wunused-parameter: this is really common when implementing
   #   interfaces, etc.
   # disable -Wpointer-arith: this is a GCC extension, and doesn't work in MSVC.
@@ -256,6 +264,8 @@
 add_custom_target(everything)
 
 set(WABT_LIBRARY_SRC
+  ${WABT_BINARY_DIR}/config.h
+
   src/apply-names.h
   src/apply-names.cc
   src/binary.h
@@ -276,7 +286,7 @@
   src/color.cc
   src/common.h
   src/common.cc
-  src/config.h
+  src/config.h.in
   src/config.cc
   src/decompiler.h
   src/decompiler-ast.h
@@ -372,12 +382,6 @@
   target_link_libraries(wasm wabt)
   target_include_directories(wasm PUBLIC third_party/wasm-c-api/include)
   if (COMPILER_IS_MSVC)
-    if (WERROR)
-      target_compile_options(wasm PRIVATE -WX)
-    endif ()
     target_compile_definitions(wasm PRIVATE "WASM_API_EXTERN=__declspec(dllexport)")
   else ()
-    if (WERROR)
-      target_compile_options(wasm PRIVATE -Werror)
-    endif ()
     target_compile_options(wasm PRIVATE $<$<COMPILE_LANGUAGE:CXX>:-Wno-old-style-cast>)

=== wasm2c/examples/rot13/Makefile ===
# Use implicit rules for compiling C files.
CFLAGS=-I../..

all: rot13

clean:
	rm -rf rot13 rot13.wasm rot13.c *.o

rot13: main.o rot13.o ../../wasm-rt-impl.o -lm

rot13.wasm: rot13.wat ../../../bin/wat2wasm
	../../../bin/wat2wasm $< -o $@

rot13.c: rot13.wasm ../../../bin/wasm2c
	../../../bin/wasm2c $< -o $@

.PHONY: all clean

=== debian/changelog ===
wabt (1.0.28-1) unstable; urgency=medium

  * New upstream version 1.0.28.

 -- Markus Koschany <apo@debian.org>  Thu, 28 Apr 2022 23:22:11 +0200

## wabt 1.0.29

=== CMakeLists.txt ===
--- 
+++ 
@@ -14,11 +14,12 @@
 # limitations under the License.
 #
 
-cmake_minimum_required(VERSION 3.0.0)
-project(WABT LANGUAGES C CXX VERSION 1.0.28)
+cmake_minimum_required(VERSION 3.1.0)
+project(WABT LANGUAGES C CXX VERSION 1.0.29)
 include(GNUInstallDirs)
 
-set(CXX_STANDARD 17)
+set(CMAKE_CXX_STANDARD 17)
+set(CMAKE_CXX_STANDARD_REQUIRED ON)
 
 if (POLICY CMP0077)
   cmake_policy(SET CMP0077 NEW)
@@ -131,7 +132,6 @@
   # disable warnings C4267 and C4244: conversion/truncation from larger to smaller type.
   # disable warning C4800: implicit conversion from larger int to bool
   add_definitions(-W3 -wd4018 -wd4056 -wd4756 -wd4267 -wd4244 -wd4800 -D_CRT_SECURE_NO_WARNINGS -D_SCL_SECURE_NO_WARNINGS)
-  add_definitions(/std:c++${CXX_STANDARD})
 
   if (NOT WITH_EXCEPTIONS)
     # disable exception use in C++ library
@@ -154,7 +154,7 @@
   )
 
   set(CMAKE_CXX_EXTENSIONS OFF)
-  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++${CXX_STANDARD} -Wold-style-cast")
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wold-style-cast")
 
   if (NOT WITH_EXCEPTIONS)
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-exceptions")

=== Makefile ===
--- 
+++ 
@@ -146,6 +146,7 @@
 
 .PHONY: update-wasm2c
 update-wasm2c: src/prebuilt/wasm2c.include.c src/prebuilt/wasm2c.include.h
+	make -C wasm2c/examples/fac
 
 src/prebuilt/wasm2c.include.c: src/wasm2c.c.tmpl
 	src/wasm2c_tmpl.py -o $@ $<

=== debian/changelog ===
wabt (1.0.29-1) unstable; urgency=medium

  * New upstream version 1.0.29.
  * Declare compliance with Debian Policy 4.6.1.

 -- Markus Koschany <apo@debian.org>  Sat, 28 May 2022 14:03:04 +0200
